
; ========================================================
;			
;    -- DirectSoundTest.asm --
;			Jay Sullivan
; ========================================================
  

.386
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include DirectSoundTest.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		BtnWndProc PROTO hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
		CoCreateDS PROTO DummyParam:DWORD
		CopyToSoundBuffer PROTO pBlock1:DWORD, sizeBlock1:DWORD, pBlock2:DWORD, sizeBlock2:DWORD, pSrcData:DWORD
		GenerateSineWave PROTO pToneListMember:DWORD
		
		ToneListAdd    PROTO pFrequency:DWORD
		ToneListDelete PROTO pToneListMember:DWORD
		DeleteAllToneListMembers PROTO
;------------------------------------------------
;                .CODE
;------------------------------------------------

.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke GetProcessHeap
		mov hHeap,eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL wc:WNDCLASSEX
LOCAL msg:MSG
LOCAL hwnd:HWND



	;------------------------------------------------
	;	Windows
	;------------------------------------------------
			
		;------------------------------------------------
		;	Main Window Register
		;------------------------------------------------
		
			mov wc.cbSize, Sizeof WNDCLASSEX
			mov wc.style, CS_HREDRAW or CS_VREDRAW
			mov wc.lpfnWndProc, Offset WndProc
			mov wc.cbClsExtra,NULL
			mov wc.cbWndExtra,NULL
			mov eax,hInst
			mov wc.hInstance,eax
			mov wc.hbrBackground, COLOR_WINDOW+1
			mov wc.lpszMenuName, NULL
			mov wc.lpszClassName, Offset ClassName
			invoke LoadIcon, NULL, IDI_APPLICATION
			mov wc.hIcon,eax
			mov wc.hIconSm,0
			invoke LoadCursor, NULL, IDC_ARROW
			mov wc.hCursor,eax
			invoke RegisterClassEx, ADDR wc
		
		
		;------------------------------------------------
		;	Main Window Create
		;------------------------------------------------
		
				
			invoke CreateWindowEx, WS_EX_CLIENTEDGE, ADDR ClassName, ADDR szAppName,\
				WS_OVERLAPPEDWINDOW,\
				CW_USEDEFAULT,CW_USEDEFAULT,230,180,\
				NULL,NULL,hInst,NULL
			mov hwnd,eax

	;------------------------------------------------
	;	WinMain Code
	;------------------------------------------------
			
		;-----------------------------
		;	Show Window
		;-----------------------------
			
			invoke ShowWindow, hwnd, SW_SHOWNORMAL 
			invoke UpdateWindow, hwnd
			
		;-----------------------------
		;	Message Loop
		;-----------------------------
			
			jmp @F
			StartLoop:
			  invoke TranslateMessage,ADDR msg
			  invoke DispatchMessage, ADDR msg
			@@:
			  invoke GetMessage,ADDR msg,NULL,0,0
			  test eax, eax
			  jnz StartLoop
			
	mov eax, msg.wParam
	ret
WinMain ENDP


;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL wc:WNDCLASSEX 
	;-----------------------------
	 .if uMsg==WM_CREATE
	;-----------------------------
			mov eax, hWnd
			mov hMainWindow, eax
    ;-----------------------------------------------------------------
    ;  Halts all sound and clears them from memory
    ;-----------------------------------------------------------------
	   	invoke CreateEvent, NULL, FALSE, FALSE, 0
		mov hMasterHalt, eax	
    ;-----------------------------------------------------------------
    ;  Access to altering linked list
    ;-----------------------------------------------------------------
		invoke CreateMutex, NULL, FALSE, NULL
		mov hMutexAccessList, eax
    ;-----------------------------------------------------------------
    ;  Superclass buttons
    ;-----------------------------------------------------------------
		mov wc.cbSize, Sizeof WNDCLASSEX 
        invoke GetClassInfoEx, NULL, Offset szCButton, ADDR wc 
        mov eax, wc.lpfnWndProc 
        mov OldBtnProc, eax 
        mov wc.lpfnWndProc, Offset BtnWndProc 
        mov eax, hInstance 
        mov wc.hInstance, eax 
        mov wc.lpszClassName, Offset szCSButton 
        invoke RegisterClassEx, addr wc 

    ;-----------------------------------------------------------------
    ;  COM
    ;-----------------------------------------------------------------

  
  		invoke CoInitializeEx, NULL, COINIT_MULTITHREADED 
  		
  		
    ;-----------------------------------------------------------------
    ;  Create an IDirectSound8 object
    ;-----------------------------------------------------------------
		
  	    ;-----------------------------------------------------------------
	    ;  Get a pointer to the IDirectSound8 interface. 
	    ;-----------------------------------------------------------------
    		mov pIDirectSound, 0
		    invoke CoCreateInstance, ADDR CLSID_IDirectSound8, NULL, CLSCTX_INPROC_SERVER, 
		                             ADDR IID_IDirectSound8,
		                             ADDR pIDirectSound
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("CoCreateInstance"), $String("Failed"), MB_OK or MB_ICONERROR
		    .endif
	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::Initialize
	    ;-----------------------------------------------------------------
	      	coinvoke pIDirectSound, IDirectSound8, Initialize, NULL
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::Initialize"), $String("Failed"), MB_OK or MB_ICONERROR
		    .endif
	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::SetCooperativeLevel
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSound, IDirectSound8, SetCooperativeLevel,\
            		 hWnd, \
            		 1  ; 1 = DSSCL_NORMAL
            		 	; 2 = DSSCL_PRIORITY 
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::SetCooperativeLevel"), $String("Failed"), MB_OK or MB_ICONERROR
		    .endif
  		
	;------------------------------------------------
	;	myButton Create
	;------------------------------------------------
	
		invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCButton, $String("HALT"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,120,0,120,35,hWnd,0,hInstance,  0
		mov hHaltButton, eax
		invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCSButton, $String("220.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,0,120,35,hWnd,0,hInstance,  Offset $double(220.0)
		invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCSButton, $String("440.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,35,120,35,hWnd,0,hInstance, Offset $double(440.0)
		invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCSButton, $String("349.22823143300"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,70,120,35,hWnd,0,hInstance, Offset $double(349.22823143300)
		invoke CreateWindowEx, WS_EX_STATICEDGE, Offset szCSButton, $String("880.0"), WS_VISIBLE or WS_CHILD or WS_BORDER or ES_LEFT,0,105,120,35,hWnd,0,hInstance,Offset $double(880.0)

	    ;-----------------------------------------------------------------
	    ;  Start the noise
	    ;-----------------------------------------------------------------
		    
		    invoke CreateThread, 0, 0, Offset CoCreateDS, 0, 0, 0
		    
		    
		    CreateFail:
		    
	;-----------------------------
	 .elseif uMsg==WM_COMMAND
	;-----------------------------
	
	
		mov eax, wParam
		.if ax== BN_CLICKED
			mov eax, lParam
			.if  eax== hHaltButton
				invoke SetEvent, hMasterHalt
			.else
				
				invoke GetWindowLong, lParam,GWL_USERDATA
				invoke ToneListAdd,  eax
			.endif
			
		.endif
		
		
	;-----------------------------
	 .elseif uMsg==WM_DESTROY
	;-----------------------------
	
	
		.if pIDirectSound != 0
		    ;-----------------------------------------------------------------
		    ;  IDirectSound8::Release
		    ;-----------------------------------------------------------------
		     coinvoke pIDirectSound, IDirectSound8, Release
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::Release"), $String("Failed"), MB_OK or MB_ICONERROR
		    .endif
		.endif
		
		invoke CoUninitialize
		invoke PostQuitMessage, NULL
		
	;-----------------------------
	 .else
	;-----------------------------
		
		invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		ret
		
	;-----------------------------
	 .endif
	;-----------------------------
	
	xor eax,eax
	ret
WndProc ENDP

;---------------------------------------------------------------------
CoCreateDS PROC DummyParam:DWORD
  
	      
    LOCAL   pIDirectSoundBufferRoot:DWORD
    LOCAL   pIDirectSoundBuffer8Root:DWORD
    LOCAL   pIDirectSoundNotify:DWORD
    
    LOCAL pIDirectSoundSecondaryBuffer:DWORD ; temp storage
	LOCAL pCurrentToneListMember:DWORD ; iterator
    
    LOCAL outBufferAddr2:DWORD,  ; [out]
    	  outBufferSize2:DWORD,  ; [out]
          outBufferAddr1:DWORD,  ; [out]
    	  outBufferSize1:DWORD   ; [out]
    	  
   	LOCAL pPlayCursor:DWORD,
   		  pWriteCursor:DWORD
    	  
   	LOCAL pCopyBufferThird3:DWORD,
          pCopyBufferThird2:DWORD,
          pCopyBufferThird1:DWORD
  
   	LOCAL hMasterHaltCopy3:HANDLE, hEventBufferThirdDone3:HANDLE, 
          hMasterHaltCopy2:HANDLE, hEventBufferThirdDone2:HANDLE, 
          hMasterHaltCopy1:HANDLE, hEventBufferThirdDone1:HANDLE
          
	LOCAL myDSPosNotify3:DSBPOSITIONNOTIFY,
	      myDSPosNotify2:DSBPOSITIONNOTIFY,
	      myDSPosNotify1:DSBPOSITIONNOTIFY
	      
	
    ;-----------------------------------------------------------------
    ;  Buffer Notify Events
    ;-----------------------------------------------------------------
		
	   	invoke CreateEvent,  NULL, FALSE, FALSE, 0
		mov hEventBufferThirdDone1, eax
		mov myDSPosNotify2._DSBPOSITIONNOTIFY.hEventNotify, eax
		mov myDSPosNotify2._DSBPOSITIONNOTIFY.dwOffset, 29399  ; 1/3
		
	   	invoke CreateEvent,  NULL, FALSE, FALSE, 0
		mov hEventBufferThirdDone2, eax
		mov myDSPosNotify3._DSBPOSITIONNOTIFY.hEventNotify, eax
		mov myDSPosNotify3._DSBPOSITIONNOTIFY.dwOffset, 58799  ; 2/3
		
	   	invoke CreateEvent,  NULL, FALSE, FALSE, 0
		mov hEventBufferThirdDone3, eax
		mov myDSPosNotify1._DSBPOSITIONNOTIFY.hEventNotify, eax
		mov myDSPosNotify1._DSBPOSITIONNOTIFY.dwOffset, 88199     ; 3/3
		
    ;-----------------------------------------------------------------
    ;  Create a copy of hMasterHalt so it is in the event list
    ;-----------------------------------------------------------------
		mov eax, hMasterHalt
		mov hMasterHaltCopy1, eax
		mov hMasterHaltCopy2, eax
		mov hMasterHaltCopy3, eax
		
		
		
		
		
    ;-----------------------------------------------------------------
    ;  Create an IDirectSoundBuffer object
    ;-----------------------------------------------------------------
    
    	mov pIDirectSoundBufferRoot, 0
	    ;-----------------------------------------------------------------
	    ;  IDirectSound8::CreateSoundBuffer
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSound, IDirectSound8, CreateSoundBuffer,\
            		 Offset DirectSoundRootDesc,\
            		 ADDR pIDirectSoundBufferRoot,\
            		 NULL
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSound8::CreateSoundBuffer [pIDirectSoundBufferRoot]"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		    
    ;-----------------------------------------------------------------
    ;  Create an IDirectSoundBuffer8 object
    ;-----------------------------------------------------------------
    
    	mov pIDirectSoundBuffer8Root, 0
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer::QueryInterface(IID_IDirectSoundBuffer8)
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBufferRoot, IDirectSoundBuffer, QueryInterface,\
            		 Offset IID_IDirectSoundBuffer8,\
            		 ADDR pIDirectSoundBuffer8Root
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer::QueryInterface(IID_IDirectSoundBuffer8)"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		
    ;-----------------------------------------------------------------
    ;  Create an IDirectSoundNotify object
    ;-----------------------------------------------------------------
    
    	mov pIDirectSoundNotify, 0
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer8::QueryInterface(IID_IDirectSoundNotify)
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBuffer8Root, IDirectSoundBuffer8, QueryInterface,\
            		 Offset IID_IDirectSoundNotify,\
            		 ADDR pIDirectSoundNotify
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::QueryInterface(IID_IDirectSoundNotify)"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		    
		    
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundNotify::SetNotificationPositions
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundNotify, IDirectSoundNotify, SetNotificationPositions,\
            		 3,\
            		 ADDR myDSPosNotify1
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundNotify::SetNotificationPositions"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		    
  
	comment ^
;-----------------------------------------------------------------
;  DEBUG SECTION: MAKES A CLICK TO JUDGE WHEN THE LOOP RESTARTS
;-----------------------------------------------------------------
    	;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer8::Lock
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBuffer8Root, IDirectSoundBuffer8, Lock, \
             	0,\    ; dwWriteCursor:DWORD,
                88100,\ ; dwWriteBytes:DWORD, 
                ADDR outBufferAddr1,\
                ADDR outBufferSize1,\
                ADDR outBufferAddr2,\ 
                ADDR outBufferSize2,\ 
                DSBLOCK_ENTIREBUFFER ; dwFlags:DWORD
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Lock"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
	    ;-----------------------------------------------------------------
	    ;  Write to buffer
	    ;-----------------------------------------------------------------
		    mov eax, outBufferAddr1
		    mov word ptr [eax], 5555
	    ;-----------------------------------------------------------------
	    ;  IDirectSoundBuffer8::Unlock
	    ;-----------------------------------------------------------------
            coinvoke pIDirectSoundBuffer8Root, IDirectSoundBuffer8, Unlock, \
               outBufferAddr1,\
               outBufferSize1,\
               outBufferAddr2,\ 
               outBufferSize2
		    .if eax!=0
		    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Unlock"), $String("Failed"), MB_OK or MB_ICONERROR
		    	jmp ErrorDelete
		    .endif
		    
		 ^
  
    
    
	mov SoundBufferIndex, 0
	
    ;-----------------------------------------------------------------
    ;  IDirectSoundBuffer8::Play
    ;-----------------------------------------------------------------
        coinvoke pIDirectSoundBuffer8Root, IDirectSoundBuffer8, Play, \
            0,\
            0,\
            DSBPLAY_LOOPING
	    .if eax!=0
	    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Play"), $String("Failed"), MB_OK or MB_ICONERROR
	    	jmp ErrorDelete
	  	.endif
	  	
		  	
    ;-----------------------------------------------------------------
    ;  THIS IS WHERE TO BEGIN AFTER WE HALT
    ;-----------------------------------------------------------------   
  	
 RepeatLoop:
    ;-----------------------------------------------------------------
    ;  DO THE FOLLOWING 
    ;              foreach {} = TO EACH LIST MEMBER
    ;-----------------------------------------------------------------

    ;---------------------------
    ;  Play Dummy Buffer [blank]
    ;  Wait For 3/3 to start
    ;
    ; RepeatLoop:
    ;  foreach { Generate Scratch Buffer }
    ;  foreach { Write 1/3 }
    ;  -> Wait For 1/3 to start
    ;  foreach { Write 2/3 }
    ;  -> Wait For 2/3 to start
    ;  foreach { Play }
    ;  foreach { Write 3/3 }
    ;  -> Wait For 3/3 to start
    ;
    ; jmp RepeatLoop
    ;---------------------------
    
  
	  
    ;=================================================================
    ;  <foreach "Generate Scratch Buffer">
    ;=================================================================
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
		
		;-----------------------------------------------------------------
		;  FirstMember
		;-----------------------------------------------------------------
		mov pCurrentToneListMember, Offset ToneListRoot
		.while TRUE
		
		    ;-----------------------------------------------------------------
		    ;  Next Member
		    ;-----------------------------------------------------------------
		  	mov eax, pCurrentToneListMember
		  	mov eax, [eax].ToneListMember.NextMember
		  	mov pCurrentToneListMember, eax
		  	.if eax==0
		  		.break
		  	.endif
		  	mov eax, [eax].ToneListMember.pSecondaryBuffer
		  	mov pIDirectSoundSecondaryBuffer, eax
		    
		    ;-----------------------------------------------------------------
		    ;  Generate Sine Wave
		    ;-----------------------------------------------------------------
		    	invoke GenerateSineWave, pCurrentToneListMember
			  	
		.endw
		
		;-----------------------------------------------------------------
		; Increase SoundBufferIndex - since loop is done
		;-----------------------------------------------------------------
			add SoundBufferIndex, 44100
		
	;-----------------------------------------------------------------
	; Release Mutex
	;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
    ;=================================================================
    ;  </foreach>
    ;=================================================================
			
	 			
	;=================================================================
    ;  <foreach "Play">
    ;=================================================================
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
		
		;-----------------------------------------------------------------
		;  FirstMember
		;-----------------------------------------------------------------
		mov pCurrentToneListMember, Offset ToneListRoot
		.while TRUE
		
		    ;-----------------------------------------------------------------
		    ;  Next Member
		    ;-----------------------------------------------------------------
		  	mov eax, pCurrentToneListMember
		  	mov eax, [eax].ToneListMember.NextMember
		  	mov pCurrentToneListMember, eax
		  	.if eax==0
		  		.break
		  	.endif
		  	mov eax, [eax].ToneListMember.pSecondaryBuffer
		  	mov pIDirectSoundSecondaryBuffer, eax
		    
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Play
		    ;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Play, \
	                0,\
	                0,\
	                DSBPLAY_LOOPING
			    .if eax!=0
			    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Play"), $String("Failed"), MB_OK or MB_ICONERROR
			    	jmp ErrorDelete
			  	.endif
			  	
		.endw
		
		
	;-----------------------------------------------------------------
	; Release Mutex
	;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
    ;=================================================================
    ;  </foreach>
    ;=================================================================
			
			
	;=================================================================
    ;  <foreach "Write 1/3">
    ;=================================================================    
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
		    	    
	
		;-----------------------------------------------------------------
		;  Start at first member
		;-----------------------------------------------------------------
			mov pCurrentToneListMember, Offset ToneListRoot
			
		;-----------------------------------------------------------------
		;  Loop through members
		;-----------------------------------------------------------------
		.while TRUE
			
		    ;-----------------------------------------------------------------
		    ;  Next Member
		    ;-----------------------------------------------------------------
		  	mov eax, pCurrentToneListMember
		  	mov eax, [eax].ToneListMember.NextMember
		  	mov pCurrentToneListMember, eax
		  	.if eax==0
		  		.break
		  	.endif
		  	mov eax, [eax].ToneListMember.pSecondaryBuffer
		  	mov pIDirectSoundSecondaryBuffer, eax
		    	
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Lock
		    ;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Lock, \
	             	0,\ ; dwWriteCursor:DWORD,
	                29400,\ ; dwWriteBytes:DWORD, 
	                ADDR outBufferAddr1,\
	                ADDR outBufferSize1,\
	                ADDR outBufferAddr2,\ 
	                ADDR outBufferSize2,\ 
	                0 ; dwFlags:DWORD
			    .if eax!=0
			    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Lock"), $String("Failed"), MB_OK or MB_ICONERROR
			    	jmp ErrorDelete
			    .endif
		    ;-----------------------------------------------------------------
		    ;  Write to buffer
		    ;-----------------------------------------------------------------
		    
			    ;-----------------------------------------------------------------
			    ;  Get pointer to scratch buffer 1/3
			    ;-----------------------------------------------------------------
			    mov eax, pCurrentToneListMember
			  	mov eax, [eax].ToneListMember.pScratchBuffer
					
				invoke CopyToSoundBuffer, outBufferAddr1,outBufferSize1, outBufferAddr2,outBufferSize2, eax
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Unlock
		    ;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Unlock, \
	                outBufferAddr1,\
	                outBufferSize1,\
	                outBufferAddr2,\ 
	                outBufferSize2
			    .if eax!=0
			    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Unlock"), $String("Failed"), MB_OK or MB_ICONERROR
			    	jmp ErrorDelete
			    .endif
			    
		.endw
		
	
	;-----------------------------------------------------------------
	; Release Mutex
	;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
	;=================================================================
    ;  </foreach>
    ;=================================================================
    
		
		    	 
    ;=================================================================
    ;  -> Wait For 1/3 to start <-
    ;=================================================================
			
			;-----------------------------------------------------------------
			; Wait for signal or halt
			;-----------------------------------------------------------------
			invoke WaitForMultipleObjects, 2, ADDR hEventBufferThirdDone3, FALSE, 10000 ; Wait for 1/3 to start
			.if eax == 1
				jmp ErrorHalt
			.endif
			
	;=================================================================
    ;  <foreach "Write 2/3">
    ;=================================================================
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
		  
		;-----------------------------------------------------------------
		;  Start at first member
		;-----------------------------------------------------------------
		mov pCurrentToneListMember, Offset ToneListRoot
		;-----------------------------------------------------------------
		;  Loop through members
		;-----------------------------------------------------------------
		.while TRUE
	
			;-----------------------------------------------------------------
			;  Next Member
			;-----------------------------------------------------------------
			mov eax, pCurrentToneListMember
			mov eax, [eax].ToneListMember.NextMember
			mov pCurrentToneListMember, eax
			.if eax==0
				.break
			.endif
			mov eax, [eax].ToneListMember.pSecondaryBuffer
			mov pIDirectSoundSecondaryBuffer, eax
			
			;-----------------------------------------------------------------
			;  IDirectSoundBuffer8::Lock
			;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Lock, \
	             	29400,\    ; dwWriteCursor:DWORD,
	                29400,\ ; dwWriteBytes:DWORD, 
	               ADDR outBufferAddr1,\
	               ADDR outBufferSize1,\
	               ADDR outBufferAddr2,\ 
	               ADDR outBufferSize2,\ 
	                0 ; dwFlags:DWORD
				.if eax!=0
					invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Lock"), $String("Failed"), MB_OK or MB_ICONERROR
					jmp ErrorDelete
				.endif
				
			;-----------------------------------------------------------------
			;  Write to buffer
			;-----------------------------------------------------------------
				
				;-----------------------------------------------------------------
				;  Get pointer to scratch buffer 2/3
				;-----------------------------------------------------------------
				mov eax, pCurrentToneListMember
				mov eax, [eax].ToneListMember.pScratchBuffer
				add eax, 29400
				;-----------------------------------------------------------------
				;  Copy Buffer
				;-----------------------------------------------------------------
				invoke CopyToSoundBuffer, outBufferAddr1,outBufferSize1, outBufferAddr2,outBufferSize2, eax
				
			;-----------------------------------------------------------------
			;  IDirectSoundBuffer8::Unlock
			;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Unlock, \
	               outBufferAddr1,\
	               outBufferSize1,\
	               outBufferAddr2,\ 
	               outBufferSize2
				.if eax!=0
					invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Unlock"), $String("Failed"), MB_OK or MB_ICONERROR
					jmp ErrorDelete
				.endif
		.endw
		
	    	
	;-----------------------------------------------------------------
	; Release Mutex
	;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
	;=================================================================
    ;  </foreach>
    ;=================================================================
	
	;=================================================================
    ;  -> Wait For 2/3 to start <-
    ;=================================================================
			
			;-----------------------------------------------------------------
			; Wait for signal or halt
			;-----------------------------------------------------------------
			invoke WaitForMultipleObjects, 2, ADDR hEventBufferThirdDone1, FALSE, 10000 ; Wait for 2/3 to start
			.if eax == 1
				jmp ErrorHalt
			.endif
    
	;=================================================================
    ;  <foreach "Write 3/3">
    ;=================================================================
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
	    
		;-----------------------------------------------------------------
		;  Start at first member
		;-----------------------------------------------------------------
		mov pCurrentToneListMember, Offset ToneListRoot
		
		;-----------------------------------------------------------------
		;  Loop through members
		;-----------------------------------------------------------------
		.while TRUE
		
		    ;-----------------------------------------------------------------
		    ;  Next Member
		    ;-----------------------------------------------------------------
		  	mov eax, pCurrentToneListMember
		  	mov eax, [eax].ToneListMember.NextMember
		  	mov pCurrentToneListMember, eax
		  	.if eax==0
		  		.break
		  	.endif
		  	mov eax, [eax].ToneListMember.pSecondaryBuffer
		  	mov pIDirectSoundSecondaryBuffer, eax
	  	
		    	
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Lock
		    ;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Lock, \
	             	58800,\    ; dwWriteCursor:DWORD,
	                29400,\ ; dwWriteBytes:DWORD, 
	                ADDR outBufferAddr1,\
	                ADDR outBufferSize1,\
	                ADDR outBufferAddr2,\ 
	                ADDR outBufferSize2,\ 
	                0 ; dwFlags:DWORD
			    .if eax!=0
			    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Lock"), $String("Failed"), MB_OK or MB_ICONERROR
			    	jmp ErrorDelete
			    .endif
		    ;-----------------------------------------------------------------
		    ;  Write to buffer
		    ;-----------------------------------------------------------------
		    
			    ;-----------------------------------------------------------------
			    ;  Get pointer to scratch buffer 3/3
			    ;-----------------------------------------------------------------
			    mov eax, pCurrentToneListMember
			  	mov eax, [eax].ToneListMember.pScratchBuffer
			  	add eax, 58800
					
				invoke CopyToSoundBuffer, outBufferAddr1,outBufferSize1, outBufferAddr2,outBufferSize2, eax
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Unlock
		    ;-----------------------------------------------------------------
	            coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Unlock, \
	                outBufferAddr1,\
	                outBufferSize1,\
	                outBufferAddr2,\ 
	                outBufferSize2
			    .if eax!=0
			    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer8::Unlock"), $String("Failed"), MB_OK or MB_ICONERROR
			    	jmp ErrorDelete
			    .endif
			    
		.endw
	 
			
	;-----------------------------------------------------------------
	; Release Mutex
	;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
	
	;=================================================================
    ;  </foreach>
    ;=================================================================
    
    ;=================================================================
    ;  -> Wait For 3/3 to start <-
    ;=================================================================
			
			;-----------------------------------------------------------------
			; Wait for signal or halt
			;-----------------------------------------------------------------
			invoke WaitForMultipleObjects, 2, ADDR hEventBufferThirdDone2, FALSE, 10000 ; Wait for 3/3 to start
			.if eax == 1
				jmp ErrorHalt
			.endif
	 		

    ;=================================================================
    ;  REPEAT
    ;=================================================================
		    
		    
		    jmp RepeatLoop
		    
		    
	  ErrorHalt:
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
	  
	  
		
		;-----------------------------------------------------------------
		;  Start at first member
		;-----------------------------------------------------------------
			mov pCurrentToneListMember, Offset ToneListRoot
			
		;-----------------------------------------------------------------
		;  Loop through members
		;-----------------------------------------------------------------
		.while TRUE
				
			;-----------------------------------------------------------------
			;  Next Member
			;-----------------------------------------------------------------
				mov eax, pCurrentToneListMember
				mov eax, [eax].ToneListMember.NextMember
				mov pCurrentToneListMember, eax
				.if eax==0
					.break
				.endif
				mov eax, [eax].ToneListMember.pSecondaryBuffer
				mov pIDirectSoundSecondaryBuffer, eax
				
			;-----------------------------------------------------------------
			;  IDirectSound8::Stop
			;-----------------------------------------------------------------
				coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Stop
				.if eax!=0
					invoke MessageBox, hMainWindow, $String("IDirectSound8::Stop"), $String("Failed"), MB_OK or MB_ICONERROR
					jmp ErrorDelete
				.endif
				
		.endw
		
		
		;-----------------------------------------------------------------
		; Alert
		;-----------------------------------------------------------------
			
			invoke MessageBox, hMainWindow, $String("HALT!"), $String("Halted"), MB_OK or MB_ICONASTERISK
			
		;-----------------------------------------------------------------
		; Release mutex and delete
		;-----------------------------------------------------------------
			
			invoke ReleaseMutex, hMutexAccessList
			
		;-----------------------------------------------------------------
		; Clear up Memory
		;-----------------------------------------------------------------
			
			invoke DeleteAllToneListMembers
			
		;-----------------------------------------------------------------
		; Go back up
		;-----------------------------------------------------------------
			
			jmp RepeatLoop
			
			
ErrorDelete:
       
  	
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
	  
	  
	;-----------------------------------------------------------------
    ;  IDirectSound8::Stop
    ;-----------------------------------------------------------------
     coinvoke pIDirectSoundBuffer8Root, IDirectSoundBuffer8, Stop
     .if eax!=0
    	invoke MessageBox, hMainWindow, $String("IDirectSound8::Stop"), $String("Failed"), MB_OK or MB_ICONERROR
    	jmp ErrorDelete
     .endif
		
		;-----------------------------------------------------------------
		;  Start at first member
		;-----------------------------------------------------------------
			mov pCurrentToneListMember, Offset ToneListRoot
			
		;-----------------------------------------------------------------
		;  Loop through members
		;-----------------------------------------------------------------
		.while TRUE
				
			;-----------------------------------------------------------------
			;  Next Member
			;-----------------------------------------------------------------
				mov eax, pCurrentToneListMember
				mov eax, [eax].ToneListMember.NextMember
				mov pCurrentToneListMember, eax
				.if eax==0
					.break
				.endif
				mov eax, [eax].ToneListMember.pSecondaryBuffer
				mov pIDirectSoundSecondaryBuffer, eax
				
			;-----------------------------------------------------------------
			;  IDirectSound8::Stop
			;-----------------------------------------------------------------
				coinvoke pIDirectSoundSecondaryBuffer, IDirectSoundBuffer8, Stop
				.if eax!=0
					invoke MessageBox, hMainWindow, $String("IDirectSound8::Stop"), $String("Failed"), MB_OK or MB_ICONERROR
					jmp ErrorDelete
				.endif
				
		.endw
		
       
		;-----------------------------------------------------------------
		; Stop events from triggering
		;-----------------------------------------------------------------
   		invoke CloseHandle, hEventBufferThirdDone3
   		invoke CloseHandle, hEventBufferThirdDone2
   		invoke CloseHandle, hEventBufferThirdDone1
          
		.if pIDirectSoundNotify != 0
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundNotify::Release
		    ;-----------------------------------------------------------------
		     coinvoke pIDirectSoundNotify, IDirectSoundNotify, Release
		.endif
		.if pIDirectSoundBuffer8Root != 0
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer8::Release
		    ;-----------------------------------------------------------------
		     coinvoke pIDirectSoundBuffer8Root, IDirectSoundBuffer8, Release
		.endif
		.if pIDirectSoundBufferRoot != 0
		    ;-----------------------------------------------------------------
		    ;  IDirectSoundBuffer::Release
		    ;-----------------------------------------------------------------
		     coinvoke pIDirectSoundBufferRoot, IDirectSoundBuffer, Release
		.endif
		
      
	;-----------------------------------------------------------------
	; Release mutex and delete
	;-----------------------------------------------------------------
	  invoke ReleaseMutex, hMutexAccessList
		
	;-----------------------------------------------------------------
	; Clear up Memory
	;-----------------------------------------------------------------
      invoke DeleteAllToneListMembers
     
     
		
    ret
CoCreateDS ENDP
;---------------------------------------------------------------------


GenerateSineWave PROC pToneListMember:DWORD
LOCAL sinmulti:REAL8
LOCAL tempBufferIndex:DWORD


	  ;-----------------------------------------------------------------
      ; 44100 sps @  2 bytes per sample  
      ; = 88200 bytes per second
	  ;-----------------------------------------------------------------
	  ; a sine wave with frequency F hertz will be of wavelength
	  ; 88200/F  bytes
	  ;-----------------------------------------------------------------
	  ;- value of sample[n] = sin(2 * pi * 88200 /  F / n) ) * amplitude
	  ;-----------------------------------------------------------------
      
		    ;-----------------------------------------------------------------
		    ;  tempBufferIndex - so we don't change the global one
		    ;-----------------------------------------------------------------
		    	mov eax, SoundBufferIndex
		    	mov tempBufferIndex, eax
		    
		    ;-----------------------------------------------------------------
		    ;  Load up "sinmulti"   ( 2*pi*44100 / F)
		    ;-----------------------------------------------------------------
				    mov eax, pToneListMember
				    mov eax, [eax].ToneListMember.pFrequency
					fldpi
					fmul real8 ptr [eax]
					fidiv $Const(88200); (x2) ? channels
					fstp sinmulti
			  
		    ;-----------------------------------------------------------------
		    ;  Write sample[n] sound to buffer        
		    ;-----------------------------------------------------------------
		     mov eax, pToneListMember
		     mov eax, [eax].ToneListMember.pScratchBuffer
		     mov ecx, 44100
		     mov edx, 0
		     .while ecx>0
		     	add tempBufferIndex, 1
		     	
		     	fld sinmulti
		     	fimul tempBufferIndex
		     	fsin
		     	fimul $Const(32767)
		     	fistp word ptr [eax+edx]
		     	
		     	add edx, 2
		     	sub ecx, 1
		     .endw
		     
	ret
GenerateSineWave ENDP

CopyToSoundBuffer PROC pBlock1:DWORD, sizeBlock1:DWORD, pBlock2:DWORD, sizeBlock2:DWORD, pSrcData:DWORD
push edi
push esi
			  
		     mov esi, pSrcData
		    ;-----------------------------------------------------------------
		    ;  Write sample[n] sound to buffer1
		    ;-----------------------------------------------------------------
		     mov edi, pBlock1
		     mov ecx, sizeBlock1
		     rep movsb
			 
		    ;-----------------------------------------------------------------
		    ;  Write sample[n] sound to buffer2
		    ;-----------------------------------------------------------------
		     mov edi, pBlock2
		     mov ecx, sizeBlock2
		     rep movsb
		     
	pop esi
	pop edi
	ret
CopyToSoundBuffer ENDP

BtnWndProc PROC hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD 
;LOCAL pUserData:DWORD

	mov eax, uMsg
	.if eax== WM_CREATE

	    ;-----------------------------------------------------------------
	    ;  Set user data to point to the frequency constant
	    ;-----------------------------------------------------------------
		mov eax, lParam
		invoke SetWindowLong, hWnd,GWL_USERDATA, dword ptr [eax]
		
		
	.elseif eax== WM_DESTROY
		;invoke GetWindowLong, hWnd,GWL_USERDATA
		;invoke HeapFree, hHeap, NULL, eax
	.endif
	
	invoke CallWindowProc,OldBtnProc,hWnd,uMsg,wParam,lParam 
	ret
BtnWndProc ENDP



;-----------------------------------------------------------------
;  Adds onto a linked list of ToneListMember structures
;-----------------------------------------------------------------
ToneListAdd PROC pFrequency:DWORD
LOCAL pToneListStub:DWORD,
	  pToneListMember:DWORD,
	  pTempDirectSoundBuffer:DWORD
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	  invoke WaitForSingleObject, hMutexAccessList, 10000
	  
	;-----------------------------------------------------------------
	; Find last ToneListMember in the list
	;-----------------------------------------------------------------
	mov eax, Offset ToneListRoot
	.while [eax].ToneListMember.NextMember != 0
		mov eax, [eax].ToneListMember.NextMember
	.endw
	mov pToneListStub, eax
	
	;-----------------------------------------------------------------
	; Allocate new ToneListMember
	;-----------------------------------------------------------------
	
	invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, Sizeof ToneListMember
	mov pToneListMember, eax
	
	;-----------------------------------------------------------------
	; Allocate new ScratchBuffer
	;-----------------------------------------------------------------
	
	invoke HeapAlloc, hHeap,HEAP_ZERO_MEMORY, 88200
	mov ecx, pToneListMember
	mov [ecx].ToneListMember.pScratchBuffer, eax
	
	
	
		
	
	;-----------------------------------------------------------------
	; Initialize  ToneListMember
	;-----------------------------------------------------------------
	mov eax, pToneListMember
	mov ecx, pToneListStub
	mov edx, pFrequency
	mov [ecx].ToneListMember.NextMember, eax
	mov [eax].ToneListMember.LastMember, ecx
	mov [eax].ToneListMember.pFrequency, edx
	
	
	
	
    ;-----------------------------------------------------------------
    ;  Create an IDirectSoundBuffer object
    ;-----------------------------------------------------------------
    ;-----------------------------------------------------------------
    ;  IDirectSound8::CreateSoundBuffer
    ;-----------------------------------------------------------------
        coinvoke pIDirectSound, IDirectSound8, CreateSoundBuffer,\
        		 Offset DirectSoundSecondaryDesc,\
        		 ADDR pTempDirectSoundBuffer,\
        		 NULL
	    .if eax!=0
	    	invoke MessageBox, hMainWindow, $String("IDirectSound8::CreateSoundBuffer [secondary]"), $String("Failed"), MB_OK or MB_ICONERROR

	    	ret
	    .endif
		    
		    
    ;-----------------------------------------------------------------
    ;  Create an IDirectSoundBuffer8 object
    ;-----------------------------------------------------------------
    ;-----------------------------------------------------------------
    ;  IDirectSoundBuffer::QueryInterface(IID_IDirectSoundBuffer8)
    ;-----------------------------------------------------------------
		mov ecx, pToneListMember
        coinvoke pTempDirectSoundBuffer, IDirectSoundBuffer, QueryInterface,\
        		 Offset IID_IDirectSoundBuffer8,\
        		 ADDR [ecx].ToneListMember.pSecondaryBuffer
	    .if eax!=0
	    	invoke MessageBox, hMainWindow, $String("IDirectSoundBuffer::QueryInterface(IID_IDirectSoundBuffer8)"), $String("Failed"), MB_OK or MB_ICONERROR
	    	invoke ToneListDelete, pToneListMember
	    .endif
		    
		  	
    ;-----------------------------------------------------------------
    ;  Release Mutex
    ;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
	    
	    
	ret
ToneListAdd ENDP

;-----------------------------------------------------------------
;  Deletes a specified ToneListMember
;-----------------------------------------------------------------
ToneListDelete PROC pToneListMember:DWORD

    ;-----------------------------------------------------------------
    ;  Attach child and parent
    ;-----------------------------------------------------------------
	mov eax, pToneListMember
	mov ecx, [eax].ToneListMember.LastMember
	mov edx, [eax].ToneListMember.NextMember
	
	mov [ecx].ToneListMember.NextMember, edx  ; (*X.Parent).Child =  X.Child
	.if edx!=0
	mov [edx].ToneListMember.LastMember, ecx  ; (*X.Child).Parent =  X.Parent
	.endif
	
    ;-----------------------------------------------------------------
    ;  Free scratch buffer
    ;-----------------------------------------------------------------
	mov eax, pToneListMember
	invoke HeapFree, hHeap, 0, [eax].ToneListMember.pScratchBuffer
	
    ;-----------------------------------------------------------------
    ;  IDirectSoundBuffer8::Release
    ;-----------------------------------------------------------------
	 mov eax, pToneListMember
     coinvoke [eax].ToneListMember.pSecondaryBuffer, IDirectSoundBuffer8, Release
    
    ;-----------------------------------------------------------------
    ;  Free member
    ;-----------------------------------------------------------------
	invoke HeapFree, hHeap, 0, pToneListMember
	


	ret
ToneListDelete ENDP

;-----------------------------------------------------------------
; Deletes all ToneList members
;-----------------------------------------------------------------

DeleteAllToneListMembers PROC
	;-----------------------------------------------------------------
	; Grab Mutex
	;-----------------------------------------------------------------
	invoke WaitForSingleObject, hMutexAccessList, 10000
	
	mov eax, Offset ToneListRoot
	.while [eax].ToneListMember.NextMember != 0
		invoke ToneListDelete, [eax].ToneListMember.NextMember
		mov eax, Offset ToneListRoot
	.endw
	
    ;-----------------------------------------------------------------
    ;  Release Mutex
    ;-----------------------------------------------------------------
	invoke ReleaseMutex, hMutexAccessList
	
	ret
DeleteAllToneListMembers ENDP

End Start


